# HG changeset patch
# User Gene Harvey <gharveymn@gmail.com>
# Date 1559336962 18000
#      Fri May 31 16:09:22 2019 -0500
# Node ID 1ccb99c08f27355591d783b5f2cd592c407c0d1a
# Parent  df9e3cb79379aa358c8a83da1caa7e21208af901
fix the JIT and add support for LLVM-8

* configure.ac: Add additional check if LLVM include directory is already in
system path and call new macro.

* jit-ir.cc: Minor modernization.

* jit-ir.h: Minor modernization and readability improvements.

* jit-typeinfo.cc (octave_jit_release_matrix): Add reference count decrement.
(octave_jit_grab_matrix): Add reference count increment.
(jit_type::jit_type): Replace loop with std::array::fill and modernize member
initializer list.
(octave_jit_paren_scalar -> octave_jit_paren_scalar_subsref): Rename.
(jit_function::jit_function): Replace const& with pass-by-value and std::move.
(jit_function::call) Two new overload implementations.
(jit_paren_subsref::generate_matrix): Create a new module on creation of each
overload (bug #55492).
(jit_paren_subsref::init_paren_scalar): Adjust external function name.
(jit_paren_subsasgn::generate_matrix): Create a new module for each overload.
(jit_paren_subsasgn::init_paren_scalar): Adjust external function name.
(jit_typeinfo::jit_typeinfo): Call llvm::ConstantStruct::get with ArrayRef.

* jit-typeinfo.h (jit_type): Use std::array rather than raw array.
(jit_function::call): Six new overloads with jit_module parameter.
(jit_typeinfo::create_internal): New overload with jit_module parameter.

* jit-typeinfo.cc, jit-typeinfo.h (jit_function::type,
jit_function::print_all_flocs, jit_function::print_all_functions):
New functions.

* jit-util.cc: Remove LLVM defines.

* jit-util.h (isa): Compare dynamic_cast explicitly with nullptr.

* pt-eval.cc (tree_evaluator::visit_simple_for_command,
tree_evaluator::execute_user_function,
tree_evaluator::visit_unwind_protect_command,
tree_evaluator::visit_do_until_command): Pass the self-reference as an argument
to tree_jit::execute.

* pt-jit.cc (jit_convert::jit_convert): Initialize stack_frame member.
(jit_convert::visit_statement): Update to stack_frame system.
(jit_convert::initialize): Remove symbol_scope initializer.
(jit_convert::visit_statement, jit_convert::get_variable, jit_info::find):
Update to stack_frame system (bug #55809).
(jit_convert_llvm::convert_function): Use member module instead of argument.
(jit_convert_llvm::convert): Improve loop readability.
(jit_convert_llvm::visit): Use ArrayRef constructor and invoke
jit_function::call using the member module.
(jit_info::simplify_phi): Improve loop readability.
(jit_memory_manager): Make deleted functions public.
(jit_memory_manager::getSymbolAddress): Comment out call to
llvm::SectionMemoryManager::getSymbolAddress which would retrieve an incorrect
address with "sin" as an argument and cause a crash.
(tree_jit::do_execute): Pass tree_evaluator as an argument to jit_info.
(jit_module::getFunction): New function implementation.
(jit_module::optimize): Use autoconf macro for llvm::WriteBitcodeToFile.
(jit_function_info::jit_function_info): Initialize tree_evaluator member and
pass self-reference to jit_function::call.
(jit_info::jit_info): Initialize tree_evaluator member.
(jit_info::compile): Pass self-reference to jit_convert_llvm constructor
instead of jit_convert_llvm::convert_loop.

pt-jit.h: Add stack-frame.h to includes.
(jit_convert::m_frame): New member variable.
(jit_convert::initialize): Remove symbol_scope argument.
(jit_convert_llvm::jit_convert_llvm): New constructor.
(jit_convert_llvm::convert_loop): Remove jit_module argument.
(jit_convert_llvm::convert_function): Remove jit_module argument.
(jit_convert_llvm::m_module): New member variable.
(tree_jit::execute): Add tree_evaluator to parameters.
(tree_jit::do_execute): Add tree_evaluator to parameters.
(jit_info::jit_info): Add tree_evaluator to parameters.
(jit_info::m_tr_eval): New member variable.
(jit_function_info::jit_function_info): Add tree_evaluator to parameters.
(jit_function_info::m_tr_eval): New member variable.

* pt-jit.cc, pt-jit.h (jit_module::getFunction,
jit_module::print_object_summary, jit_module::print_all_flocs,
jit_module::print_all_functions, jit_module::dump): New functions.

* acinclude.m4 (OCTAVE_LLVM_WRITEBITCODETOFILE_API, OCTAVE_CHECK_SEARCH_PATH):
New macros.

diff -r df9e3cb79379 -r 1ccb99c08f27 configure.ac
--- a/configure.ac	Wed May 08 18:45:34 2019 -0700
+++ b/configure.ac	Fri May 31 16:09:22 2019 -0500
@@ -1377,26 +1377,40 @@
     save_CPPFLAGS="$CPPFLAGS"
     save_LDFLAGS="$LDFLAGS"
 
+    LLVM_INCLUDE_DIR="$($LLVM_CONFIG --includedir)"
+    AC_MSG_NOTICE([using LLVM_INCLUDE_DIR=$LLVM_INCLUDE_DIR])
+
     dnl Use -isystem if available because we don't want to see warnings in LLVM
-    LLVM_INCLUDE_FLAG=-I
+    LLVM_INCLUDE_FLAG="-I $LLVM_INCLUDE_DIR"
     OCTAVE_CC_FLAG([-isystem .], [
-      LLVM_INCLUDE_FLAG=-isystem
-      AC_MSG_NOTICE([using -isystem for LLVM headers])])
-
-    dnl Use -isystem so we don't get warnings from llvm headers
-    LLVM_CPPFLAGS="$LLVM_INCLUDE_FLAG `$LLVM_CONFIG --includedir`"
-    LLVM_LDFLAGS="-L`$LLVM_CONFIG --libdir`"
-
-    LDFLAGS="$LDFLAGS $LLVM_LDFLAGS"
-    LLVM_SO=LLVM-`$LLVM_CONFIG --version`
+      OCTAVE_CHECK_SEARCH_PATH(["$LLVM_INCLUDE_DIR"],
+        [AC_MSG_NOTICE([-isystem not used because LLVM_INCLUDE_DIR was found in the system search path])],
+        [LLVM_INCLUDE_FLAG="-isystem $LLVM_INCLUDE_DIR"
+         AC_MSG_NOTICE([using -isystem for LLVM headers])])])
+
+    dnl Can't use --cppflags here because earlier versions of LLVM force NDEBUG
+    LLVM_CPPFLAGS="$LLVM_INCLUDE_FLAG -D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS"
+    LLVM_LDFLAGS="$($LLVM_CONFIG --ldflags)"
+
+    dnl We can't just use -lLLVM because earlier versions do not supply the
+    dnl library by that name.
+    LLVM_SO="LLVM-$($LLVM_CONFIG --version)"
+
+    dnl Check the guessed library. If it fails fall back to --libs.
+    dnl Don't use --system-libs because earlier versions will link libedit
+    dnl which conflicts with libreadline and will cause a crash at runtime.
     AC_CHECK_LIB([$LLVM_SO], [LLVMBuildAdd], [LLVM_LIBS="-l$LLVM_SO"],
-                 [LLVM_LIBS="`$LLVM_CONFIG --libs` `$LLVM_CONFIG --system-libs`"])
-
-    dnl Define some extra flags that LLVM requires in order to include headers.
-    dnl Ideally we should get these from llvm-config, but llvm-config isn't
-    dnl very helpful.
-    CPPFLAGS="-D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS $LLVM_CPPFLAGS $CPPFLAGS"
-    AC_LANG_PUSH(C++)
+                     [LLVM_LIBS="$($LLVM_CONFIG --libs)"])
+
+    CPPFLAGS="$LLVM_CPPFLAGS $CPPFLAGS"
+    LDFLAGS="$LLVM_LDFLAGS $LDFLAGS"
+    AC_LANG_PUSH([C++])
+
+    dnl FIXME: Some of these may show warnings if LLVM is in the system
+    dnl path, but we are building with a different version of LLVM.
+    dnl The warnings don't appear to affect the final build.
+    dnl POTENTIAL FIX: Preappend the headers given to the check macros
+    dnl with $LLVM_INCLUDE_DIR/
     AC_CHECK_HEADER([llvm/Support/TargetSelect.h], [warn_llvm=""])
 
     have_function_h=no
@@ -1433,8 +1447,9 @@
     OCTAVE_LLVM_IRBUILDER_API
     OCTAVE_LLVM_HAS_CREATEALWAYSINLINERPASS
     OCTAVE_LLVM_IRBUILDER_CREATECONSTINBOUNDSGEP1_32_API
-
-    AC_LANG_POP(C++)
+    OCTAVE_LLVM_WRITEBITCODETOFILE_API
+
+    AC_LANG_POP([C++])
     CPPFLAGS="$save_CPPFLAGS"
     LDFLAGS="$save_LDFLAGS"
   fi
@@ -1642,7 +1657,7 @@
   PKG_CHECK_EXISTS([$magick++], [
     dnl Make sure we only get -I, -L, and -l flags.
     dnl Some Graphics/ImageMagick++ dnl packages add extra flags that are
-    dnl useful when building Graphics/ImageMagick++ extentions.  These extra
+    dnl useful when building Graphics/ImageMagick++ extensions.  These extra
     dnl flags break the Octave build.
     MAGICK_CPPFLAGS="$($PKG_CONFIG --cflags-only-I $magick++ | $SED -e 's/^ *$//')"
     MAGICK_LDFLAGS="$($PKG_CONFIG --libs-only-L $magick++ | $SED -e 's/^ *$//')"
diff -r df9e3cb79379 -r 1ccb99c08f27 libinterp/parse-tree/jit-ir.cc
--- a/libinterp/parse-tree/jit-ir.cc	Wed May 08 18:45:34 2019 -0700
+++ b/libinterp/parse-tree/jit-ir.cc	Fri May 31 16:09:22 2019 -0500
@@ -22,17 +22,15 @@
 
 // Author: Max Brister <max@2bass.com>
 
-// defines required by llvm
-#define __STDC_LIMIT_MACROS
-#define __STDC_CONSTANT_MACROS
-
 #if defined (HAVE_CONFIG_H)
 #  include "config.h"
 #endif
 
 #if defined (HAVE_LLVM)
 
+#include "error.h"
 #include "jit-ir.h"
+#include "oct.h"
 
 #if defined (HAVE_LLVM_IR_FUNCTION_H)
 #  include <llvm/IR/BasicBlock.h>
@@ -42,17 +40,14 @@
 #  include <llvm/Instructions.h>
 #endif
 
-#include "error.h"
-
 namespace octave
 {
 
   // -------------------- jit_factory --------------------
   jit_factory::~jit_factory (void)
   {
-    for (auto iter = m_all_values.begin ();
-         iter != m_all_values.end (); ++iter)
-      delete *iter;
+    for (jit_value *& m_all_value : m_all_values)
+      delete m_all_value;
   }
 
   void
@@ -93,7 +88,7 @@
   void
   jit_block_list::label (void)
   {
-    if (m_list.size ())
+    if (! m_list.empty ())
       {
         jit_block *block = m_list.back ();
         block->label ();
@@ -111,10 +106,10 @@
   jit_block_list::print_dom (std::ostream& os) const
   {
     os << "-------------------- dom info --------------------\n";
-    for (auto iter = begin (); iter != end (); ++iter)
+    for (const jit_block *jblock : *this)
       {
-        assert (*iter);
-        (*iter)->print_dom (os);
+        assert (jblock);
+        jblock->print_dom (os);
       }
     os << std::endl;
 
@@ -132,10 +127,10 @@
   std::ostream&
   operator<<(std::ostream& os, const jit_block_list& blocks)
   {
-    for (auto iter = blocks.begin (); iter != blocks.end (); ++iter)
+    for (const jit_block *jblock : blocks)
       {
-        assert (*iter);
-        (*iter)->print (os, 0);
+        assert (jblock);
+        jblock->print (os, 0);
       }
     return os << std::endl;
   }
@@ -148,9 +143,6 @@
   }
 
   // -------------------- jit_value --------------------
-  jit_value::~jit_value (void)
-  { }
-
   jit_block *
   jit_value::first_use_block (void)
   {
@@ -163,7 +155,7 @@
         use = use->next ();
       }
 
-    return 0;
+    return nullptr;
   }
 
   void
@@ -277,7 +269,7 @@
         return to_merge;
       }
 
-    return 0;
+    return nullptr;
   }
 
   void
@@ -404,27 +396,27 @@
     os << "  predecessors: ";
     for (jit_use *use = first_use (); use; use = use->next ())
       os << *use->user_parent () << ' ';
-    os << std::endl;
+    os << '\n';
 
     os << "  successors: ";
     for (size_t i = 0; i < successor_count (); ++i)
       os << *successor (i) << ' ';
-    os << std::endl;
+    os << '\n';
 
     os << "  m_idom: ";
     if (m_idom)
       os << *m_idom;
     else
       os << "NULL";
-    os << std::endl;
+    os << '\n';
     os << "  df: ";
     for (auto iter = df_begin (); iter != df_end (); ++iter)
       os << **iter << ' ';
-    os << std::endl;
+    os << '\n';
 
     os << "  m_dom_succ: ";
-    for (size_t i = 0; i < m_dom_succ.size (); ++i)
-      os << *m_dom_succ[i] << ' ';
+    for (const jit_block *jblock : m_dom_succ)
+      os << *jblock << ' ';
 
     return os << std::endl;
   }
@@ -504,9 +496,8 @@
   void
   jit_block::pop_all (void)
   {
-    for (auto iter = begin (); iter != end (); ++iter)
+    for (jit_instruction *instr : *this)
       {
-        jit_instruction *instr = *iter;
         instr->pop_variable ();
       }
   }
@@ -523,14 +514,13 @@
         if (use->next ())
           os << ", ";
       }
-    os << std::endl;
+    os << '\n';
 
-    for (auto iter = begin (); iter != end (); ++iter)
+    for (const jit_instruction *instr : *this)
       {
-        jit_instruction *instr = *iter;
-        instr->print (os, indent + 1) << std::endl;
+        instr->print (os, indent + 1) << '\n';
       }
-    return os;
+    return os.flush();
   }
 
   jit_block *
@@ -610,7 +600,7 @@
         if (inc->branch_alive (p))
           {
             if (unique != argument (i))
-              unique = 0;
+              unique = nullptr;
 
             if (new_idx != i)
               {
@@ -698,12 +688,6 @@
     return changed;
   }
 
-  llvm::TerminatorInst *
-  jit_terminator::to_llvm (void) const
-  {
-    return llvm::cast<llvm::TerminatorInst> (jit_value::to_llvm ());
-  }
-
   // -------------------- jit_call --------------------
   bool
   jit_call::needs_release (void) const
@@ -785,8 +769,8 @@
       m_count (factory.create<jit_const_index> (acount))
   { }
 
-  jit_magic_end::jit_magic_end (const std::vector<context>& full_context)
-    : m_contexts (full_context)
+  jit_magic_end::jit_magic_end (std::vector<context> full_context)
+    : m_contexts (std::move(full_context))
   {
     resize_arguments (m_contexts.size ());
 
diff -r df9e3cb79379 -r 1ccb99c08f27 libinterp/parse-tree/jit-ir.h
--- a/libinterp/parse-tree/jit-ir.h	Wed May 08 18:45:34 2019 -0700
+++ b/libinterp/parse-tree/jit-ir.h	Fri May 31 16:09:22 2019 -0500
@@ -184,10 +184,11 @@
   public:
 
     jit_value (void)
-      : m_llvm_value (0), m_type (0), m_last_use (0), m_in_worklist (false)
+      : m_llvm_value (nullptr), m_type (nullptr), m_last_use (nullptr),
+        m_in_worklist (false)
     { }
 
-    virtual ~jit_value (void);
+    virtual ~jit_value (void) = default;
 
     bool in_worklist (void) const
     {
@@ -245,7 +246,7 @@
 
     bool has_llvm (void) const
     {
-      return m_llvm_value;
+      return m_llvm_value != nullptr;
     }
 
     llvm::Value * to_llvm (void) const
@@ -285,8 +286,8 @@
   {
   public:
 
-    // some compilers don't allow us to use jit_internal_node without template
-    // paremeters
+    // Some compilers don't allow us to use jit_internal_node without template
+    // parameters
     typedef jit_internal_node<jit_value, jit_use> PARENT_T;
 
     jit_use (void) : m_user (0), m_index (0) { }
@@ -312,7 +313,7 @@
     std::list<jit_block *> user_parent_location (void) const;
 
     void stash_value (jit_value *avalue, jit_instruction *auser = nullptr,
-                      size_t aindex = -1)
+                      size_t aindex = std::numeric_limits<size_t>::max())
     {
       PARENT_T::stash_value (avalue);
       m_index = aindex;
@@ -493,7 +494,7 @@
     std::list<jit_instruction *>::iterator m_location;
   };
 
-  // defnie accept methods for subclasses
+  // define accept methods for subclasses
 #define JIT_VALUE_ACCEPT                        \
   virtual void accept (jit_ir_walker& walker);
 
@@ -1100,8 +1101,6 @@
 
     virtual bool infer (void);
 
-    llvm::TerminatorInst * to_llvm (void) const;
-
   protected:
 
     virtual bool check_alive (size_t) const { return true; }
@@ -1305,7 +1304,8 @@
     {
     public:
 
-      context (void) : m_value (0), m_index (0), m_count (0) { }
+      context (void) : m_value (nullptr), m_index (nullptr), m_count (nullptr)
+      { }
 
       context (jit_factory& factory, jit_value *avalue, size_t aindex,
                size_t acount);
@@ -1315,7 +1315,7 @@
       jit_const_index *m_count;
     };
 
-    jit_magic_end (const std::vector<context>& full_context);
+    explicit jit_magic_end (std::vector<context> full_context);
 
     virtual bool infer (void);
 
@@ -1373,7 +1373,7 @@
   {
   public:
 
-    jit_store_argument (jit_variable *var)
+    explicit jit_store_argument (jit_variable *var)
       : jit_instruction (var), m_dest (var)
     { }
 
diff -r df9e3cb79379 -r 1ccb99c08f27 libinterp/parse-tree/jit-typeinfo.cc
--- a/libinterp/parse-tree/jit-typeinfo.cc	Wed May 08 18:45:34 2019 -0700
+++ b/libinterp/parse-tree/jit-typeinfo.cc	Fri May 31 16:09:22 2019 -0500
@@ -22,10 +22,6 @@
 
 // Author: Max Brister <max@2bass.com>
 
-// defines required by llvm
-#define __STDC_LIMIT_MACROS
-#define __STDC_CONSTANT_MACROS
-
 #if defined (HAVE_CONFIG_H)
 #  include "config.h"
 #endif
@@ -64,15 +60,16 @@
 
 #include <llvm/Support/raw_os_ostream.h>
 
+#include "interpreter-private.h"
 #include "jit-typeinfo.h"
-#include "pt-jit.h"
 #include "jit-ir.h"
-#include "ov.h"
+#include "oct.h"
 #include "ov-builtin.h"
 #include "ov-complex.h"
 #include "ov-scalar.h"
+#include "ov.h"
 #include "pager.h"
-#include "interpreter-private.h"
+#include "pt-jit.h"
 
 namespace octave
 {
@@ -128,7 +125,8 @@
   extern "C" void
   octave_jit_release_matrix (jit_matrix *m)
   {
-    delete m->m_array;
+    if(--(*(m->m_ref_count)) == 0)
+      delete m->m_array;
   }
 
   extern "C" octave_base_value *
@@ -141,6 +139,7 @@
   extern "C" jit_matrix
   octave_jit_grab_matrix (jit_matrix *m)
   {
+    ++(*(m->m_ref_count));
     return *m->m_array;
   }
 
@@ -260,8 +259,8 @@
   }
 
   extern "C" double
-  octave_jit_paren_scalar (jit_matrix *mat, double *indicies,
-                           octave_idx_type idx_count)
+  octave_jit_paren_scalar_subsref (jit_matrix *mat, double *indicies,
+                           	   octave_idx_type idx_count)
   {
     // FIXME: Replace this with a more optimal version
     Array<idx_vector> idx;
@@ -378,7 +377,7 @@
   octave_jit_complex_mul (Complex lhs, Complex rhs)
   {
     if (lhs.imag () == 0 && rhs.imag() == 0)
-      return Complex (lhs.real () * rhs.real (), 0);
+      return {lhs.real () * rhs.real (), 0};
 
     return lhs * rhs;
   }
@@ -471,7 +470,7 @@
            || (ovl.length () == 1 && ovl.xelem (0).is_undefined ())))
       err_bad_result ();
 
-    return 0;
+    return nullptr;
   }
 
 
@@ -504,18 +503,14 @@
 
   // -------------------- jit_type --------------------
 
-  jit_type::jit_type (const std::string& aname, jit_type *aparent,
+  jit_type::jit_type (std::string aname, jit_type *aparent,
                       llvm::Type *allvm_type, bool askip_paren, int aid)
-    : m_name (aname), m_parent (aparent), m_llvm_type (allvm_type), m_id (aid),
-      m_depth (aparent ? aparent->m_depth + 1 : 0), m_skip_paren (askip_paren)
+    : m_name (std::move (aname)), m_parent (aparent), m_llvm_type (allvm_type),
+      m_id (aid), m_depth (aparent ? aparent->m_depth + 1 : 0),
+      m_skip_paren (askip_paren), m_sret {}, m_pointer_arg {}, m_pack {},
+      m_unpack {}, m_packed_type {}
   {
-    std::memset (m_sret, 0, sizeof (m_sret));
-    std::memset (m_pointer_arg, 0, sizeof (m_pointer_arg));
-    std::memset (m_pack, 0, sizeof (m_pack));
-    std::memset (m_unpack, 0, sizeof (m_unpack));
-
-    for (size_t i = 0; i < jit_convention::length; ++i)
-      m_packed_type[i] = m_llvm_type;
+    m_packed_type.fill (m_llvm_type);
   }
 
   llvm::Type *
@@ -565,8 +560,8 @@
   jit_function::jit_function (const jit_module *amodule,
                               jit_convention::type acall_conv,
                               const llvm::Twine& aname, jit_type *aresult,
-                              const std::vector<jit_type *>& aargs)
-    : m_module (amodule), m_result (aresult), m_args (aargs),
+                              std::vector<jit_type *> aargs)
+    : m_module (amodule), m_result (aresult), m_args (std::move (aargs)),
       m_call_conv (acall_conv), m_can_error (false)
   {
     llvm::SmallVector<llvm::Type *, 15> llvm_args;
@@ -582,9 +577,8 @@
           }
       }
 
-    for (auto iter = m_args.cbegin (); iter != m_args.cend (); ++iter)
+    for (jit_type *ty : m_args)
       {
-        jit_type *ty = *iter;
         assert (ty);
         llvm::Type *argty = ty->packed_type (m_call_conv);
         if (ty->pointer_arg (m_call_conv))
@@ -617,16 +611,10 @@
   }
 
   jit_function::jit_function (const jit_function& fn, jit_type *aresult,
-                              const std::vector<jit_type *>& aargs)
+                              std::vector<jit_type *> aargs)
     : m_module (fn.m_module), m_llvm_function (fn.m_llvm_function),
-      m_result (aresult), m_args (aargs), m_call_conv (fn.m_call_conv),
-      m_can_error (fn.m_can_error)
-  { }
-
-  jit_function::jit_function (const jit_function& fn)
-    : m_module (fn.m_module), m_llvm_function (fn.m_llvm_function),
-      m_result (fn.m_result), m_args (fn.m_args), m_call_conv (fn.m_call_conv),
-      m_can_error (fn.m_can_error)
+      m_result (aresult), m_args (std::move (aargs)),
+      m_call_conv (fn.m_call_conv), m_can_error (fn.m_can_error)
   { }
 
   void
@@ -636,7 +624,13 @@
       return;
 
     m_llvm_function->eraseFromParent ();
-    m_llvm_function = 0;
+    m_llvm_function = nullptr;
+  }
+
+  llvm::FunctionType *
+  jit_function::type (void) const
+  {
+    return m_llvm_function->getFunctionType();
   }
 
   std::string
@@ -739,6 +733,105 @@
   }
 
   llvm::Value *
+  jit_function::call (const jit_module& amodule, llvm::IRBuilderD& builder,
+                      const std::vector<jit_value *>& in_args) const
+  {
+    if (! valid ())
+      throw jit_fail_exception ("Call not implemented");
+
+    assert (in_args.size () == m_args.size ());
+    std::vector<llvm::Value *> llvm_args (m_args.size ());
+    for (size_t i = 0; i < in_args.size (); ++i)
+      llvm_args[i] = in_args[i]->to_llvm ();
+
+    return call (amodule, builder, llvm_args);
+  }
+
+  llvm::Value *
+  jit_function::call (const jit_module& amodule, llvm::IRBuilderD& builder,
+                      const arg_vec& in_args) const
+  {
+    if (! valid ())
+      throw jit_fail_exception ("Call not implemented");
+
+    assert (in_args.size () == m_args.size ());
+    llvm::SmallVector<llvm::Value *, 10> llvm_args;
+    llvm_args.reserve (in_args.size () + sret ());
+
+    llvm::BasicBlock *insert_block = builder.GetInsertBlock ();
+    llvm::Function *parent = insert_block->getParent ();
+    assert (parent);
+
+    // Insert allocas inside the prelude block to prevent stack overflows
+    llvm::BasicBlock& prelude = parent->getEntryBlock ();
+    llvm::IRBuilder<> pre_builder (&prelude, prelude.begin ());
+
+    llvm::AllocaInst *sret_mem = nullptr;
+    if (sret ())
+    {
+      sret_mem = pre_builder.CreateAlloca (m_result->packed_type (m_call_conv));
+      llvm_args.push_back (sret_mem);
+    }
+
+    for (size_t i = 0; i < in_args.size (); ++i)
+    {
+      llvm::Value *arg = in_args[i];
+      jit_type::convert_fn convert = m_args[i]->pack (m_call_conv);
+      if (convert)
+        arg = convert (builder, arg);
+
+      if (m_args[i]->pointer_arg (m_call_conv))
+      {
+        llvm::Type *ty = m_args[i]->packed_type (m_call_conv);
+        llvm::Value *alloca = pre_builder.CreateAlloca (ty);
+        builder.CreateStore (arg, alloca);
+        arg = alloca;
+      }
+
+      llvm_args.push_back (arg);
+    }
+
+    // Create function declaration
+    llvm::Function *f_decl;
+    if(&amodule != m_module)
+    {
+      f_decl = amodule.getFunction(name());
+      if(!f_decl)
+      {
+        f_decl = amodule.create_llvm_function(type(), name());
+      }
+    }
+    else {
+      f_decl = m_llvm_function;
+    }
+
+    llvm::CallInst *callinst = builder.CreateCall (f_decl, llvm_args);
+    llvm::Value *ret = callinst;
+
+    if (sret ())
+      {
+#if defined (CALLINST_ADDATTRIBUTE_ARG_IS_ATTRIBUTES)
+        llvm::AttrBuilder attr_builder;
+        attr_builder.addAttribute(llvm::Attributes::StructRet);
+        llvm::Attributes attrs = llvm::Attributes::get(context, attr_builder);
+        callinst->addAttribute (1, attrs);
+#else
+        callinst->addAttribute (1, llvm::Attribute::StructRet);
+#endif
+        ret = builder.CreateLoad (sret_mem);
+      }
+
+    if (m_result)
+      {
+        jit_type::convert_fn unpack = m_result->unpack (m_call_conv);
+        if (unpack)
+          ret = unpack (builder, ret);
+      }
+
+    return ret;
+  }
+
+  llvm::Value *
   jit_function::argument (llvm::IRBuilderD& builder, size_t idx) const
   {
     assert (idx < m_args.size ());
@@ -799,10 +892,10 @@
   // -------------------- jit_operation --------------------
   jit_operation::~jit_operation (void)
   {
-    for (auto iter = m_generated.begin (); iter != m_generated.end (); ++iter)
+    for (generated_map::value_type& iter : m_generated)
       {
-        delete iter->first;
-        delete iter->second;
+        delete iter.first;
+        delete iter.second;
       }
   }
 
@@ -880,7 +973,7 @@
          ++i)
       idx(i) = types[i]->type_id ();
 
-    if (types.size () == 0)
+    if (types.empty ())
       idx(0) = idx(1) = 0;
     if (types.size () == 1)
       {
@@ -912,7 +1005,7 @@
   jit_function *
   jit_operation::generate (const signature_vec&) const
   {
-    return 0;
+    return nullptr;
   }
 
   bool
@@ -948,12 +1041,12 @@
         jit_type *scalar = jit_typeinfo::get_scalar ();
         for (size_t i = 1; i < types.size (); ++i)
           if (types[i] != scalar)
-            return 0;
+            return nullptr;
 
         return generate_matrix (types);
       }
 
-    return 0;
+    return nullptr;
   }
 
   llvm::Value *
@@ -994,12 +1087,18 @@
     if (m_paren_scalar == nullptr)
       panic_impossible ();
 
-    std::stringstream ss;
-    ss << "jit_paren_subsref_matrix_scalar" << (types.size () - 1);
+    std::string fname =
+        "jit_paren_subsref_matrix_scalar" + std::to_string(types.size () - 1);
+
+    // Cannot add this overload to the base module because this may run after
+    // it has already been finalized
+    // FIXME: This is just a hack to get the system working. We should refactor
+    // the module system to just have jm_list handle everything.
+    jit_module *module = new jit_module (fname + "_module");
 
     // FIXME: Where will this be deleted?
     jit_function *fn = new jit_function
-      (m_typeinfo.create_internal (ss.str (), m_typeinfo.m_scalar, types));
+      (m_typeinfo.create_internal (module, fname, m_typeinfo.m_scalar, types));
 
     fn->mark_can_error ();
     llvm::BasicBlock *body = fn->new_block ();
@@ -1011,6 +1110,8 @@
     llvm::Value *mat = fn->argument (builder, 0);
     llvm::Value *ret = m_paren_scalar->call (builder, mat, array, nelem);
     fn->do_return (builder, ret);
+    module->finalizeObject();
+
     return fn;
   }
 
@@ -1023,8 +1124,8 @@
     types[2] = m_typeinfo.m_index;
 
     m_paren_scalar = new jit_function
-      (m_typeinfo.create_external (&octave_jit_paren_scalar,
-                                   "octave_jit_paren_scalar",
+      (m_typeinfo.create_external (&octave_jit_paren_scalar_subsref,
+                                   "octave_jit_paren_scalar_subsref",
                                    m_typeinfo.m_scalar, types));
 
     m_paren_scalar->mark_can_error ();
@@ -1047,12 +1148,17 @@
     if (m_paren_scalar == nullptr)
       panic_impossible ();
 
-    std::stringstream ss;
-    ss << "jit_paren_subsasgn_matrix_scalar" << (types.size () - 2);
+    std::string fname =
+        "jit_paren_subsasgn_matrix_scalar" + std::to_string (types.size () - 2);
+
+    // Cannot add this overload to the base module because this may run after
+    // it has already been finalized
+    // FIXME: See jit_paren_subsref::generate_matrix
+    jit_module * module = new jit_module(fname + "_module");
 
     // FIXME: Where will this be deleted?
     jit_function *fn = new jit_function
-      (m_typeinfo.create_internal (ss.str (), m_typeinfo.m_matrix, types));
+      (m_typeinfo.create_internal (module, fname, m_typeinfo.m_matrix, types));
 
     fn->mark_can_error ();
     llvm::BasicBlock *body = fn->new_block ();
@@ -1066,6 +1172,7 @@
     llvm::Value *value = fn->argument (builder, types.size () - 1);
     llvm::Value *ret = m_paren_scalar->call (builder, mat, array, nelem, value);
     fn->do_return (builder, ret);
+    module->finalizeObject();
 
     return fn;
   }
@@ -1081,7 +1188,7 @@
 
     m_paren_scalar = new jit_function
       (m_typeinfo.create_external (&octave_jit_paren_scalar_subsasgn,
-                                   "octave_jit_paren_scalar",
+                                   "octave_jit_paren_scalar_subsasgn",
                                    m_typeinfo.m_matrix, types));
 
     m_paren_scalar->mark_can_error ();
@@ -1118,7 +1225,7 @@
   }
 
   // wrap function names to simplify jit_typeinfo::create_external
-#define JIT_FN(fn) &fn, #fn
+#define JIT_FN(fn) &(fn), #fn
 
   jit_typeinfo::jit_typeinfo (void)
     : paren_subsref_fn (*this),
@@ -1281,19 +1388,19 @@
       {
         octave_value::binary_op op = static_cast<octave_value::binary_op> (i);
         std::string op_name = octave_value::binary_op_as_string (op);
-        m_binary_ops.push_back (jit_operation ("binary" + op_name));
+        m_binary_ops.emplace_back("binary" + op_name);
       }
 
     for (size_t i = 0; i < octave_value::num_unary_ops; ++i)
       {
         octave_value::unary_op op = static_cast<octave_value::unary_op> (i);
         std::string op_name = octave_value::unary_op_as_string (op);
-        m_unary_ops.push_back (jit_operation ("unary" + op_name));
+        m_unary_ops.emplace_back("unary" + op_name);
       }
 
     for (int op = 0; op < octave_value::num_binary_ops; ++op)
       {
-        const llvm::Twine &fn_name =
+        const llvm::Twine& fn_name =
           "octave_jit_binary_any_any_" + llvm::Twine (op);
 
         fn = create_internal (fn_name, m_any, m_any, m_any);
@@ -1661,13 +1768,13 @@
       llvm::Value *inc = fn.argument (m_builder, 2);
       llvm::Value *nelem = compute_nelem.call (m_builder, base, limit, inc);
 
-      llvm::Value *dzero = llvm::ConstantFP::get (m_scalar_t, 0);
-      llvm::Value *izero = llvm::ConstantInt::get (m_index_t, 0);
-      llvm::Value *rng = llvm::ConstantStruct::get (m_range_t, dzero, dzero,
-                                                    dzero, izero, NULL);
-      rng = m_builder.CreateInsertValue (rng, base, 0);
+      llvm::Constant *dzero = llvm::ConstantFP::get (m_scalar_t, 0);
+      llvm::Constant *izero = llvm::ConstantInt::get (m_index_t, 0);
+      llvm::ArrayRef<llvm::Constant *> store {dzero, dzero, dzero, izero};
+      llvm::Value *rng = llvm::ConstantStruct::get (m_range_t, store);
+      rng = m_builder.CreateInsertValue (rng, base,  0);
       rng = m_builder.CreateInsertValue (rng, limit, 1);
-      rng = m_builder.CreateInsertValue (rng, inc, 2);
+      rng = m_builder.CreateInsertValue (rng, inc,   2);
       rng = m_builder.CreateInsertValue (rng, nelem, 3);
       fn.do_return (m_builder, rng);
     }
@@ -1964,14 +2071,13 @@
     std::vector<jit_type *> args;
     args.resize (1);
 
-    for (auto iter = m_builtins.begin ();
-         iter != m_builtins.end (); ++iter)
+    for (std::map<std::string, jit_type *>::value_type& builtin : m_builtins)
       {
-        jit_type *btype = iter->second;
+        jit_type *btype = builtin.second;
         args[0] = btype;
 
         m_grab_fn.add_overload (jit_function (grab_any, btype, args));
-        m_release_fn.add_overload (jit_function (release_any, 0, args));
+        m_release_fn.add_overload (jit_function (release_any, nullptr, args));
         m_casts[m_any->type_id ()].add_overload (jit_function (any_id, m_any,
                                                                args));
 
@@ -2015,8 +2121,8 @@
                                   m_next_id++);
     m_id_to_type.push_back (ret);
 
-    m_casts.push_back (jit_operation ("(" + name + ")"));
-    m_identities.push_back (jit_function ());
+    m_casts.emplace_back("(" + name + ")");
+    m_identities.emplace_back();
 
     return ret;
   }
@@ -2115,7 +2221,7 @@
   jit_function
   jit_typeinfo::create_identity (jit_type *type)
   {
-    size_t id = type->type_id ();
+    size_t id = static_cast<size_t>(type->type_id ());
     if (id >= m_identities.size ())
       m_identities.resize (id + 1);
 
@@ -2372,6 +2478,19 @@
 
     return m_any;
   }
+
+  void
+  jit_typeinfo::print_all_flocs ()
+  {
+    instance ().m_base_jit_module->print_all_flocs ();
+  }
+
+  void
+  jit_typeinfo::print_all_functions ()
+  {
+    instance ().m_base_jit_module->print_all_functions ();
+  }
+
 }
 
 #endif
